/*
 * mesh.h
 */

struct Vertex;
struct Triangle;

struct Vertex {
  /* public */
  float x, y, z;
  float nx, ny, nz;
  float cr, cg, cb;

  /* private */
  int tag, adj, count;
  struct Vertex *next;

  int tris_length, tris_alloc;
  int *tris;

  struct Vertex *patch_next;
};
typedef struct Vertex Vertex;
struct Triangle {
  Vertex *v[3];
  unsigned int submeshes;
};
typedef struct Triangle Triangle;


extern Vertex **vertices;
extern Triangle *triangles;
extern int vertices_length, triangles_length;


Vertex* add_vertex(int tag, float v[], float n[]);
Vertex* get_vertex(int tag);
void clear_vertices();

int add_triangle_to_vertex(Vertex *v, int t);
int add_triangle(Vertex* t[]);

void clear_triangles();

int triangle_normal(Vertex *t[3], float n[3]);
int recompute_vertex_normals();


float triangle_area(Vertex *t[3]);
