/*
 * multilevel.h
 */


#ifndef MIN
#define MIN(a, b)   ((a) < (b) ? (a) : (b))
#endif

#ifdef DEBUG
#define assert(cond)  { \
 if (!(cond)) { \
    int pop_into_debugger = 0; \
    g_print("Failed assertion at %s(%i): %s\n", __FILE__, __LINE__, #cond); \
    /* Pop into debugger */ \
    pop_into_debugger = 1 / pop_into_debugger; \
  } \
 }
#else
#define assert(cond)
#endif


/******************************************************************/
/* Win32 compatibility */
#ifdef WIN32
#pragma warning( disable : 4305 4244 )
#include <stdio.h>
#define g_print          printf
#endif


#ifdef WIN32

# include <stdlib.h>
# define MALLOC(n)      malloc(n)
# define REALLOC(p, n)  realloc(p, n)

#else

# include <glib.h>
# define MALLOC(n)      g_malloc(n)
# define REALLOC(p, n)  g_realloc(p, n)

#endif


/*******************************************************************/
/* Global config vars */
extern int detail;
extern int active;
extern float active_x, active_y, active_z;


/*******************************************************************/

int max_depth_at_point(int x, int y, int z);
int max_depth_in_box(int x, int y, int z, int sx, int sy, int sz);
